/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Contents of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.293 - (show annotations) (download)
Fri Jan 17 19:05:05 2014 UTC (5 years, 5 months ago) by mpagano
Branch: MAIN
Changes since 1.292: +1 -2 lines
Fix QA warning concerning inherit

1 # Copyright 1999-2014 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.291 2013/11/22 13:35:09 vapier Exp $
4
5 # Description: kernel.eclass rewrite for a clean base regarding the 2.6
6 # series of kernel with back-compatibility for 2.4
7 #
8 # Original author: John Mylchreest <johnm@gentoo.org>
9 # Maintainer: kernel-misc@gentoo.org
10 #
11 # Please direct your bugs to the current eclass maintainer :)
12
13 # added functionality:
14 # unipatch - a flexible, singular method to extract, add and remove patches.
15
16 # A Couple of env vars are available to effect usage of this eclass
17 # These are as follows:
18 #
19 # K_USEPV - When setting the EXTRAVERSION variable, it should
20 # add PV to the end.
21 # this is useful for thigns like wolk. IE:
22 # EXTRAVERSION would be something like : -wolk-4.19-r1
23 # K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
24 # automatically set within the kernel Makefile
25 # K_NOUSENAME - if this is set then EXTRAVERSION will not include the
26 # first part of ${PN} in EXTRAVERSION
27 # K_NOUSEPR - if this is set then EXTRAVERSION will not include the
28 # anything based on ${PR}.
29 # K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
30 # ck-sources, ac-sources) it will use PR (ie: -r5) as
31 # the patchset version for
32 # and not use it as a true package revision
33 # K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
34 # postinst and can be used to carry additional postinst
35 # messages
36 # K_EXTRAELOG - same as K_EXTRAEINFO except using elog instead of einfo
37 # K_EXTRAEWARN - same as K_EXTRAEINFO except using ewarn instead of einfo
38 # K_SYMLINK - if this is set, then forcably create symlink anyway
39 #
40 # K_DEFCONFIG - Allow specifying a different defconfig target.
41 # If length zero, defaults to "defconfig".
42 # K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
43 # combination of "base", "extras" or "experimental".
44 # K_EXP_GENPATCHES_PULL - If set, we pull "experimental" regardless of the USE FLAG
45 # but expect the ebuild maintainer to use K_EXP_GENPATCHES_LIST.
46 # K_EXP_GENPATCHES_NOUSE - If set, no USE flag will be provided for "experimental";
47 # as a result the user cannot choose to apply those patches.
48 # K_EXP_GENPATCHES_LIST - A list of patches to pick from "experimental" to apply when
49 # the USE flag is unset and K_EXP_GENPATCHES_PULL is set.
50 # K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
51 # A value of "5" would apply genpatches-2.6.12-5 to
52 # my-sources-2.6.12.ebuild
53 # K_SECURITY_UNSUPPORTED- If set, this kernel is unsupported by Gentoo Security
54 # K_DEBLOB_AVAILABLE - A value of "0" will disable all of the optional deblob
55 # code. If empty, will be set to "1" if deblobbing is
56 # possible. Test ONLY for "1".
57 # K_PREDEBLOBBED - This kernel was already deblobbed elsewhere.
58 # If false, either optional deblobbing will be available
59 # or the license will note the inclusion of freedist
60 # code.
61 # K_LONGTERM - If set, the eclass will search for the kernel source
62 # in the long term directories on the upstream servers
63 # as the location has been changed by upstream
64 # H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
65 # can be supported by the headers ebuild
66
67 # UNIPATCH_LIST - space delimetered list of patches to be applied to the
68 # kernel
69 # UNIPATCH_EXCLUDE - an addition var to support exlusion based completely
70 # on "<passedstring>*" and not "<passedno#>_*"
71 # - this should _NOT_ be used from the ebuild as this is
72 # reserved for end users passing excludes from the cli
73 # UNIPATCH_DOCS - space delimemeted list of docs to be installed to
74 # the doc dir
75 # UNIPATCH_STRICTORDER - if this is set places patches into directories of
76 # order, so they are applied in the order passed
77
78 # Changing any other variable in this eclass is not supported; you can request
79 # for additional variables to be added by contacting the current maintainer.
80 # If you do change them, there is a chance that we will not fix resulting bugs;
81 # that of course does not mean we're not willing to help.
82
83 inherit eutils toolchain-funcs versionator multilib python
84 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_preinst pkg_postinst pkg_postrm
85
86 # Added by Daniel Ostrow <dostrow@gentoo.org>
87 # This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
88 # I will remove it when I come up with something more reasonable.
89 [[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
90
91 export CTARGET=${CTARGET:-${CHOST}}
92 if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
93 export CTARGET=${CATEGORY/cross-}
94 fi
95
96 HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
97 : ${LICENSE:="GPL-2"}
98
99 # This is the latest KV_PATCH of the deblob tool available from the
100 # libre-sources upstream. If you bump this, you MUST regenerate the Manifests
101 # for ALL kernel-2 consumer packages where deblob is available.
102 : ${DEBLOB_MAX_VERSION:=38}
103
104 # No need to run scanelf/strip on kernel sources/headers (bug #134453).
105 RESTRICT="binchecks strip"
106
107 # set LINUX_HOSTCFLAGS if not already set
108 : ${LINUX_HOSTCFLAGS:="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"}
109
110 # debugging functions
111 #==============================================================
112 # this function exists only to help debug kernel-2.eclass
113 # if you are adding new functionality in, put a call to it
114 # at the start of src_unpack, or during SRC_URI/dep generation.
115 debug-print-kernel2-variables() {
116 for v in PVR CKV OKV KV KV_FULL KV_MAJOR KV_MINOR KV_PATCH RELEASETYPE \
117 RELEASE UNIPATCH_LIST_DEFAULT UNIPATCH_LIST_GENPATCHES \
118 UNIPATCH_LIST S KERNEL_URI K_WANT_GENPATCHES ; do
119 debug-print "${v}: ${!v}"
120 done
121 }
122
123 #Eclass functions only from here onwards ...
124 #==============================================================
125 handle_genpatches() {
126 local tarball
127 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return 1
128
129 debug-print "Inside handle_genpatches"
130 local OKV_ARRAY
131 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
132
133 # for > 3.0 kernels, handle genpatches tarball name
134 # genpatches for 3.0 and 3.0.1 might be named
135 # genpatches-3.0-1.base.tar.xz and genpatches-3.0-2.base.tar.xz
136 # respectively. Handle this.
137
138 for i in ${K_WANT_GENPATCHES} ; do
139 if [[ ${KV_MAJOR} -ge 3 ]]; then
140 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
141 tarball="genpatches-${KV_MAJOR}.${KV_MINOR}-${K_GENPATCHES_VER}.${i}.tar.xz"
142 else
143 tarball="genpatches-${KV_MAJOR}.${KV_PATCH}-${K_GENPATCHES_VER}.${i}.tar.xz"
144 fi
145 else
146 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.xz"
147 fi
148
149 local use_cond_start="" use_cond_end=""
150
151 if [[ "${i}" == "experimental" && -z ${K_EXP_GENPATCHES_PULL} && -z ${K_EXP_GENPATCHES_NOUSE} ]] ; then
152 use_cond_start="experimental? ( "
153 use_cond_end=" )"
154
155 if use experimental ; then
156 UNIPATCH_LIST_GENPATCHES+=" ${DISTDIR}/${tarball}"
157 debug-print "genpatches tarball: $tarball"
158 fi
159 else
160 UNIPATCH_LIST_GENPATCHES+=" ${DISTDIR}/${tarball}"
161 debug-print "genpatches tarball: $tarball"
162 fi
163
164 GENPATCHES_URI+=" ${use_cond_start}mirror://gentoo/${tarball}${use_cond_end}"
165 done
166 }
167
168 detect_version() {
169 # this function will detect and set
170 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11)
171 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1)
172 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1)
173
174 # We've already run, so nothing to do here.
175 [[ -n ${KV_FULL} ]] && return 0
176
177 # CKV is used as a comparison kernel version, which is used when
178 # PV doesnt reflect the genuine kernel version.
179 # this gets set to the portage style versioning. ie:
180 # CKV=2.6.11_rc4
181 CKV=${CKV:-${PV}}
182 OKV=${OKV:-${CKV}}
183 OKV=${OKV/_beta/-test}
184 OKV=${OKV/_rc/-rc}
185 OKV=${OKV/-r*}
186 OKV=${OKV/_p*}
187
188 KV_MAJOR=$(get_version_component_range 1 ${OKV})
189 # handle if OKV is X.Y or X.Y.Z (e.g. 3.0 or 3.0.1)
190 local OKV_ARRAY
191 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
192
193 # if KV_MAJOR >= 3, then we have no more KV_MINOR
194 #if [[ ${KV_MAJOR} -lt 3 ]]; then
195 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
196 KV_MINOR=$(get_version_component_range 2 ${OKV})
197 KV_PATCH=$(get_version_component_range 3 ${OKV})
198 if [[ ${KV_MAJOR}${KV_MINOR}${KV_PATCH} -ge 269 ]]; then
199 KV_EXTRA=$(get_version_component_range 4- ${OKV})
200 KV_EXTRA=${KV_EXTRA/[-_]*}
201 else
202 KV_PATCH=$(get_version_component_range 3- ${OKV})
203 fi
204 else
205 KV_PATCH=$(get_version_component_range 2 ${OKV})
206 KV_EXTRA=$(get_version_component_range 3- ${OKV})
207 KV_EXTRA=${KV_EXTRA/[-_]*}
208 fi
209
210 debug-print "KV_EXTRA is ${KV_EXTRA}"
211
212 KV_PATCH=${KV_PATCH/[-_]*}
213
214 local v n=0 missing
215 #if [[ ${KV_MAJOR} -lt 3 ]]; then
216 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
217 for v in CKV OKV KV_{MAJOR,MINOR,PATCH} ; do
218 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
219 done
220 else
221 for v in CKV OKV KV_{MAJOR,PATCH} ; do
222 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
223 done
224 fi
225
226 [[ $n -eq 1 ]] && \
227 eerror "Missing variables: ${missing}" && \
228 die "Failed to extract kernel version (try explicit CKV in ebuild)!"
229 unset v n missing
230
231 # if [[ ${KV_MAJOR} -ge 3 ]]; then
232 if [[ ${#OKV_ARRAY[@]} -lt 3 ]]; then
233 KV_PATCH_ARR=(${KV_PATCH//\./ })
234
235 # at this point 031412, Linus is putting all 3.x kernels in a
236 # 3.x directory, may need to revisit when 4.x is released
237 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.x"
238
239 [[ -n "${K_LONGTERM}" ]] &&
240 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_PATCH_ARR}"
241 else
242 #KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.0"
243 #KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
244 if [[ ${KV_MAJOR} -ge 3 ]]; then
245 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.x"
246 else
247 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
248 fi
249
250 [[ -n "${K_LONGTERM}" ]] &&
251 #KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm"
252 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
253 fi
254
255 debug-print "KERNEL_BASE_URI is ${KERNEL_BASE_URI}"
256
257 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
258 # handle non genpatch using sources correctly
259 if [[ -z ${K_WANT_GENPATCHES} && -z ${K_GENPATCHES_VER} && ${KV_PATCH} -gt 0 ]]; then
260 KERNEL_URI="${KERNEL_BASE_URI}/patch-${OKV}.xz"
261 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.xz"
262 fi
263 KERNEL_URI="${KERNEL_URI} ${KERNEL_BASE_URI}/linux-${KV_MAJOR}.${KV_MINOR}.tar.xz"
264 else
265 KERNEL_URI="${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
266 fi
267
268 RELEASE=${CKV/${OKV}}
269 RELEASE=${RELEASE/_beta}
270 RELEASE=${RELEASE/_rc/-rc}
271 RELEASE=${RELEASE/_pre/-pre}
272 # We cannot trivally call kernel_is here, because it calls us to detect the
273 # version
274 #kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
275 [ $(($KV_MAJOR * 1000 + ${KV_MINOR:-0})) -ge 2006 ] && RELEASE=${RELEASE/-pre/-git}
276 RELEASETYPE=${RELEASE//[0-9]}
277
278 # Now we know that RELEASE is the -rc/-git
279 # and RELEASETYPE is the same but with its numerics stripped
280 # we can work on better sorting EXTRAVERSION.
281 # first of all, we add the release
282 EXTRAVERSION="${RELEASE}"
283 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
284 [[ -n ${KV_EXTRA} ]] && [[ ${KV_MAJOR} -lt 3 ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
285
286 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
287 if [[ -n "${K_NOUSEPR}" ]]; then
288 # Don't add anything based on PR to EXTRAVERSION
289 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
290 elif [[ -n ${K_PREPATCHED} ]]; then
291 debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
292 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
293 elif [[ "${ETYPE}" = "sources" ]]; then
294 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
295 # For some sources we want to use the PV in the extra version
296 # This is because upstream releases with a completely different
297 # versioning scheme.
298 case ${PN/-*} in
299 wolk) K_USEPV=1;;
300 vserver) K_USEPV=1;;
301 esac
302
303 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
304 [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
305 [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
306 fi
307 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
308
309 # The only messing around which should actually effect this is for KV_EXTRA
310 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
311 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
312
313 if [[ -n ${KV_EXTRA} ]]; then
314 if [[ -n ${KV_MINOR} ]]; then
315 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
316 else
317 OKV="${KV_MAJOR}.${KV_PATCH}"
318 fi
319 KERNEL_URI="${KERNEL_BASE_URI}/patch-${CKV}.xz
320 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
321 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.xz"
322 fi
323
324 # We need to set this using OKV, but we need to set it before we do any
325 # messing around with OKV based on RELEASETYPE
326 KV_FULL=${OKV}${EXTRAVERSION}
327
328 # we will set this for backwards compatibility.
329 S=${WORKDIR}/linux-${KV_FULL}
330 KV=${KV_FULL}
331
332 # -rc-git pulls can be achieved by specifying CKV
333 # for example:
334 # CKV="2.6.11_rc3_pre2"
335 # will pull:
336 # linux-2.6.10.tar.xz & patch-2.6.11-rc3.xz & patch-2.6.11-rc3-git2.xz
337
338 if [[ ${KV_MAJOR}${KV_MINOR} -eq 26 ]]; then
339
340 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
341 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
342 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.xz
343 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
344 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.xz"
345 fi
346
347 if [[ ${RELEASETYPE} == -git ]]; then
348 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.xz
349 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
350 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.xz"
351 fi
352
353 if [[ ${RELEASETYPE} == -rc-git ]]; then
354 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
355 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.xz
356 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.xz
357 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
358
359 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.xz ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.xz"
360 fi
361 else
362 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
363 if [[ ${KV_MAJOR}${KV_PATCH} -eq 30 ]]; then
364 OKV="2.6.39"
365 else
366 KV_PATCH_ARR=(${KV_PATCH//\./ })
367 OKV="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
368 fi
369 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.xz
370 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
371 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.xz"
372 fi
373
374 if [[ ${RELEASETYPE} == -git ]]; then
375 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.xz
376 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
377 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.xz"
378 fi
379
380 if [[ ${RELEASETYPE} == -rc-git ]]; then
381 if [[ ${KV_MAJOR}${KV_PATCH} -eq 30 ]]; then
382 OKV="2.6.39"
383 else
384 KV_PATCH_ARR=(${KV_PATCH//\./ })
385 OKV="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
386 fi
387 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.xz
388 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.xz
389 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
390
391 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.xz ${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.xz"
392 fi
393
394
395 fi
396
397
398 debug-print-kernel2-variables
399
400 handle_genpatches
401 }
402
403 # Note: duplicated in linux-info.eclass
404 kernel_is() {
405 # ALL of these should be set before we can safely continue this function.
406 # some of the sources have in the past had only one set.
407 local v n=0
408 for v in OKV KV_{MAJOR,MINOR,PATCH} ; do [[ -z ${!v} ]] && n=1 ; done
409 [[ $n -eq 1 ]] && detect_version
410 unset v n
411
412 # Now we can continue
413 local operator test value
414
415 case ${1#-} in
416 lt) operator="-lt"; shift;;
417 gt) operator="-gt"; shift;;
418 le) operator="-le"; shift;;
419 ge) operator="-ge"; shift;;
420 eq) operator="-eq"; shift;;
421 *) operator="-eq";;
422 esac
423 [[ $# -gt 3 ]] && die "Error in kernel-2_kernel_is(): too many parameters"
424
425 : $(( test = (KV_MAJOR << 16) + (KV_MINOR << 8) + KV_PATCH ))
426 : $(( value = (${1:-${KV_MAJOR}} << 16) + (${2:-${KV_MINOR}} << 8) + ${3:-${KV_PATCH}} ))
427 [ ${test} ${operator} ${value} ]
428 }
429
430 kernel_is_2_4() {
431 kernel_is 2 4
432 }
433
434 kernel_is_2_6() {
435 kernel_is 2 6 || kernel_is 2 5
436 }
437
438 # Capture the sources type and set DEPENDs
439 if [[ ${ETYPE} == sources ]]; then
440 DEPEND="!build? (
441 sys-apps/sed
442 >=sys-devel/binutils-2.11.90.0.31
443 )"
444 RDEPEND="!build? (
445 >=sys-libs/ncurses-5.2
446 sys-devel/make
447 dev-lang/perl
448 sys-devel/bc
449 )"
450 PDEPEND="!build? ( virtual/dev-manager )"
451
452 SLOT="${PVR}"
453 DESCRIPTION="Sources based on the Linux Kernel."
454 IUSE="symlink build"
455
456 # Bug #266157, deblob for libre support
457 if [[ -z ${K_PREDEBLOBBED} ]] ; then
458 # Bug #359865, force a call to detect_version if needed
459 kernel_is ge 2 6 27 && \
460 [[ -z "${K_DEBLOB_AVAILABLE}" ]] && \
461 kernel_is le 2 6 ${DEBLOB_MAX_VERSION} && \
462 K_DEBLOB_AVAILABLE=1
463 if [[ ${K_DEBLOB_AVAILABLE} == "1" ]] ; then
464 IUSE="${IUSE} deblob python"
465 # Reflect that kernels contain firmware blobs unless otherwise
466 # stripped
467 LICENSE="${LICENSE} !deblob? ( freedist )"
468
469 if [[ -n KV_MINOR ]]; then
470 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
471 else
472 DEBLOB_PV="${KV_MAJOR}.${KV_PATCH}"
473 fi
474
475 if [[ ${KV_MAJOR} -ge 3 ]]; then
476 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}"
477 fi
478
479 DEBLOB_A="deblob-${DEBLOB_PV}"
480 DEBLOB_CHECK_A="deblob-check-${DEBLOB_PV}"
481 DEBLOB_HOMEPAGE="http://www.fsfla.org/svnwiki/selibre/linux-libre/"
482 DEBLOB_URI_PATH="download/releases/LATEST-${DEBLOB_PV}.N"
483 if ! has "${EAPI:-0}" 0 1 ; then
484 DEBLOB_CHECK_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/deblob-check -> ${DEBLOB_CHECK_A}"
485 else
486 DEBLOB_CHECK_URI="mirror://gentoo/${DEBLOB_CHECK_A}"
487 fi
488 DEBLOB_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/${DEBLOB_A}"
489 HOMEPAGE="${HOMEPAGE} ${DEBLOB_HOMEPAGE}"
490
491 #deblob script currently only works with python-2
492 PYTHON_DEPEND="python? 2"
493 PYTHON_USE_WITH_OPT="python"
494
495 KERNEL_URI="${KERNEL_URI}
496 deblob? (
497 ${DEBLOB_URI}
498 ${DEBLOB_CHECK_URI}
499 )"
500 else
501 # We have no way to deblob older kernels, so just mark them as
502 # tainted with non-libre materials.
503 LICENSE="${LICENSE} freedist"
504 fi
505 fi
506
507 elif [[ ${ETYPE} == headers ]]; then
508 DESCRIPTION="Linux system headers"
509
510 # Since we should NOT honour KBUILD_OUTPUT in headers
511 # lets unset it here.
512 unset KBUILD_OUTPUT
513
514 SLOT="0"
515 else
516 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
517 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
518 fi
519
520 # Cross-compile support functions
521 #==============================================================
522 kernel_header_destdir() {
523 [[ ${CTARGET} == ${CHOST} ]] \
524 && echo /usr/include \
525 || echo /usr/${CTARGET}/usr/include
526 }
527
528 cross_pre_c_headers() {
529 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
530 }
531
532 env_setup_xmakeopts() {
533 # Kernel ARCH != portage ARCH
534 export KARCH=$(tc-arch-kernel)
535
536 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
537 # variables properly or bad things happen !
538 xmakeopts="ARCH=${KARCH}"
539 if [[ ${CTARGET} != ${CHOST} ]] && ! cross_pre_c_headers ; then
540 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
541 elif type -p ${CHOST}-ar > /dev/null ; then
542 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
543 fi
544 export xmakeopts
545 }
546
547 # Unpack functions
548 #==============================================================
549 unpack_2_4() {
550 # this file is required for other things to build properly,
551 # so we autogenerate it
552 make -s mrproper ${xmakeopts} || die "make mrproper failed"
553 make -s symlinks ${xmakeopts} || die "make symlinks failed"
554 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
555 echo ">>> version.h compiled successfully."
556 }
557
558 unpack_2_6() {
559 # this file is required for other things to build properly, so we
560 # autogenerate it ... generate a .config to keep version.h build from
561 # spitting out an annoying warning
562 make -s mrproper ${xmakeopts} 2>/dev/null \
563 || die "make mrproper failed"
564
565 # quick fix for bug #132152 which triggers when it cannot include linux
566 # headers (ie, we have not installed it yet)
567 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
568 touch .config
569 eerror "make defconfig failed."
570 eerror "assuming you dont have any headers installed yet and continuing"
571 epause 5
572 fi
573
574 make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
575 || die "make include/linux/version.h failed"
576 rm -f .config >/dev/null
577 }
578
579 universal_unpack() {
580 debug-print "Inside universal_unpack"
581
582 local OKV_ARRAY
583 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
584
585 cd "${WORKDIR}"
586 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
587 unpack linux-${KV_MAJOR}.${KV_MINOR}.tar.xz
588 else
589 unpack linux-${OKV}.tar.xz
590 fi
591
592 if [[ -d "linux" ]]; then
593 debug-print "Moving linux to linux-${KV_FULL}"
594 mv linux linux-${KV_FULL} \
595 || die "Unable to move source tree to ${KV_FULL}."
596 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
597 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]] &&
598 [[ "${ETYPE}" = "sources" ]]; then
599 debug-print "moving linux-${KV_MAJOR}.${KV_MINOR} to linux-${KV_FULL} "
600 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
601 || die "Unable to move source tree to ${KV_FULL}."
602 else
603 debug-print "moving linux-${OKV} to linux-${KV_FULL} "
604 mv linux-${OKV} linux-${KV_FULL} \
605 || die "Unable to move source tree to ${KV_FULL}."
606 fi
607 elif [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
608 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
609 || die "Unable to move source tree to ${KV_FULL}."
610 fi
611 cd "${S}"
612
613 # remove all backup files
614 find . -iname "*~" -exec rm {} \; 2> /dev/null
615
616 }
617
618 unpack_set_extraversion() {
619 cd "${S}"
620 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
621 cd "${OLDPWD}"
622 }
623
624 # Should be done after patches have been applied
625 # Otherwise patches that modify the same area of Makefile will fail
626 unpack_fix_install_path() {
627 cd "${S}"
628 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
629 }
630
631 # Compile Functions
632 #==============================================================
633 compile_headers() {
634 env_setup_xmakeopts
635
636 # if we couldnt obtain HOSTCFLAGS from the Makefile,
637 # then set it to something sane
638 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
639 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
640
641 if kernel_is 2 4; then
642 yes "" | make oldconfig ${xmakeopts}
643 echo ">>> make oldconfig complete"
644 make dep ${xmakeopts}
645 elif kernel_is 2 6; then
646 # 2.6.18 introduces headers_install which means we dont need any
647 # of this crap anymore :D
648 kernel_is ge 2 6 18 && return 0
649
650 # autoconf.h isnt generated unless it already exists. plus, we have
651 # no guarantee that any headers are installed on the system...
652 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
653 || touch include/linux/autoconf.h
654
655 # if K_DEFCONFIG isn't set, force to "defconfig"
656 # needed by mips
657 if [[ -z ${K_DEFCONFIG} ]]; then
658 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
659 case ${CTARGET} in
660 powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
661 powerpc*) K_DEFCONFIG="pmac32_defconfig";;
662 *) K_DEFCONFIG="defconfig";;
663 esac
664 else
665 K_DEFCONFIG="defconfig"
666 fi
667 fi
668
669 # if there arent any installed headers, then there also isnt an asm
670 # symlink in /usr/include/, and make defconfig will fail, so we have
671 # to force an include path with $S.
672 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
673 ln -sf asm-${KARCH} "${S}"/include/asm
674 cross_pre_c_headers && return 0
675
676 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
677 if compile_headers_tweak_config ; then
678 yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
679 fi
680 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
681 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
682 fi
683 }
684
685 compile_headers_tweak_config() {
686 # some targets can be very very picky, so let's finesse the
687 # .config based upon any info we may have
688 case ${CTARGET} in
689 sh*)
690 sed -i '/CONFIG_CPU_SH/d' .config
691 echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
692 return 0;;
693 esac
694
695 # no changes, so lets do nothing
696 return 1
697 }
698
699 # install functions
700 #==============================================================
701 install_universal() {
702 # Fix silly permissions in tarball
703 cd "${WORKDIR}"
704 chown -R 0:0 * >& /dev/null
705 chmod -R a+r-w+X,u+w *
706 cd ${OLDPWD}
707 }
708
709 install_headers() {
710 local ddir=$(kernel_header_destdir)
711
712 # 2.6.18 introduces headers_install which means we dont need any
713 # of this crap anymore :D
714 if kernel_is ge 2 6 18 ; then
715 env_setup_xmakeopts
716 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
717
718 # let other packages install some of these headers
719 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
720 return 0
721 fi
722
723 # Do not use "linux/*" as that can cause problems with very long
724 # $S values where the cmdline to cp is too long
725 pushd "${S}" >/dev/null
726 dodir ${ddir}/linux
727 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
728 rm -rf "${D}"/${ddir}/linux/modules
729
730 dodir ${ddir}/asm
731 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
732
733 if kernel_is 2 6 ; then
734 dodir ${ddir}/asm-generic
735 cp -pPR "${S}"/include/asm-generic/* "${D}"/${ddir}/asm-generic
736 fi
737
738 # clean up
739 find "${D}" -name '*.orig' -exec rm -f {} \;
740
741 popd >/dev/null
742 }
743
744 install_sources() {
745 local file
746
747 cd "${S}"
748 dodir /usr/src
749 echo ">>> Copying sources ..."
750
751 file="$(find ${WORKDIR} -iname "docs" -type d)"
752 if [[ -n ${file} ]]; then
753 for file in $(find ${file} -type f); do
754 echo "${file//*docs\/}" >> "${S}"/patches.txt
755 echo "===================================================" >> "${S}"/patches.txt
756 cat ${file} >> "${S}"/patches.txt
757 echo "===================================================" >> "${S}"/patches.txt
758 echo "" >> "${S}"/patches.txt
759 done
760 fi
761
762 if [[ ! -f ${S}/patches.txt ]]; then
763 # patches.txt is empty so lets use our ChangeLog
764 [[ -f ${FILESDIR}/../ChangeLog ]] && \
765 echo "Please check the ebuild ChangeLog for more details." \
766 > "${S}"/patches.txt
767 fi
768
769 mv ${WORKDIR}/linux* "${D}"/usr/src
770
771 if [[ -n "${UNIPATCH_DOCS}" ]] ; then
772 for i in ${UNIPATCH_DOCS}; do
773 dodoc "${T}"/${i}
774 done
775 fi
776 }
777
778 # pkg_preinst functions
779 #==============================================================
780 preinst_headers() {
781 local ddir=$(kernel_header_destdir)
782 [[ -L ${ddir}/linux ]] && rm ${ddir}/linux
783 [[ -L ${ddir}/asm ]] && rm ${ddir}/asm
784 }
785
786 # pkg_postinst functions
787 #==============================================================
788 postinst_sources() {
789 local MAKELINK=0
790
791 # if we have USE=symlink, then force K_SYMLINK=1
792 use symlink && K_SYMLINK=1
793
794 # if we're using a deblobbed kernel, it's not supported
795 [[ $K_DEBLOB_AVAILABLE == 1 ]] && \
796 use deblob && \
797 K_SECURITY_UNSUPPORTED=deblob
798
799 # if we are to forcably symlink, delete it if it already exists first.
800 if [[ ${K_SYMLINK} > 0 ]]; then
801 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
802 MAKELINK=1
803 fi
804
805 # if the link doesnt exist, lets create it
806 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
807
808 if [[ ${MAKELINK} == 1 ]]; then
809 cd "${ROOT}"usr/src
810 ln -sf linux-${KV_FULL} linux
811 cd ${OLDPWD}
812 fi
813
814 # Don't forget to make directory for sysfs
815 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
816
817 echo
818 elog "If you are upgrading from a previous kernel, you may be interested"
819 elog "in the following document:"
820 elog " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
821 echo
822
823 # if K_EXTRAEINFO is set then lets display it now
824 if [[ -n ${K_EXTRAEINFO} ]]; then
825 echo ${K_EXTRAEINFO} | fmt |
826 while read -s ELINE; do einfo "${ELINE}"; done
827 fi
828
829 # if K_EXTRAELOG is set then lets display it now
830 if [[ -n ${K_EXTRAELOG} ]]; then
831 echo ${K_EXTRAELOG} | fmt |
832 while read -s ELINE; do elog "${ELINE}"; done
833 fi
834
835 # if K_EXTRAEWARN is set then lets display it now
836 if [[ -n ${K_EXTRAEWARN} ]]; then
837 echo ${K_EXTRAEWARN} | fmt |
838 while read -s ELINE; do ewarn "${ELINE}"; done
839 fi
840
841 # optionally display security unsupported message
842 # Start with why
843 if [[ ${K_SECURITY_UNSUPPORTED} = deblob ]]; then
844 ewarn "Deblobbed kernels may not be up-to-date security-wise"
845 ewarn "as they depend on external scripts."
846 elif [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
847 ewarn "${PN} is UNSUPPORTED by Gentoo Security."
848 fi
849 # And now the general message.
850 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
851 ewarn "This means that it is likely to be vulnerable to recent security issues."
852 ewarn "For specific information on why this kernel is unsupported, please read:"
853 ewarn "http://www.gentoo.org/proj/en/security/kernel.xml"
854 fi
855
856 # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765)
857 KV_MAJOR=$(get_version_component_range 1 ${OKV})
858 KV_MINOR=$(get_version_component_range 2 ${OKV})
859 KV_PATCH=$(get_version_component_range 3 ${OKV})
860 if [[ "$(tc-arch)" = "sparc" ]]; then
861 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]] ; then
862 echo
863 elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that"
864 elog "you now need to do"
865 elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-"
866 elog "instead of just"
867 elog " make"
868 elog "to compile the kernel. For more information please browse to"
869 elog "https://bugs.gentoo.org/show_bug.cgi?id=214765"
870 echo
871 fi
872 fi
873 }
874
875 # pkg_setup functions
876 #==============================================================
877 setup_headers() {
878 [[ -z ${H_SUPPORTEDARCH} ]] && H_SUPPORTEDARCH=${PN/-*/}
879 for i in ${H_SUPPORTEDARCH}; do
880 [[ $(tc-arch) == "${i}" ]] && H_ACCEPT_ARCH="yes"
881 done
882
883 if [[ ${H_ACCEPT_ARCH} != "yes" ]]; then
884 echo
885 eerror "This version of ${PN} does not support $(tc-arch)."
886 eerror "Please merge the appropriate sources, in most cases"
887 eerror "(but not all) this will be called $(tc-arch)-headers."
888 die "Package unsupported for $(tc-arch)"
889 fi
890 }
891
892 # unipatch
893 #==============================================================
894 unipatch() {
895 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE
896 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG
897
898 # set to a standard locale to ensure sorts are ordered properly.
899 myLC_ALL="${LC_ALL}"
900 myLANG="${LANG}"
901 LC_ALL="C"
902 LANG=""
903
904 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
905 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
906
907 # We're gonna need it when doing patches with a predefined patchlevel
908 eshopts_push -s extglob
909
910 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
911 # usage can be either via an env var or by params
912 # although due to the nature we pass this within this eclass
913 # it shall be by param only.
914 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
915 UNIPATCH_LIST="${@}"
916
917 #unpack any passed tarballs
918 for i in ${UNIPATCH_LIST}; do
919 if echo ${i} | grep -qs -e "\.tar" -e "\.tbz" -e "\.tgz" ; then
920 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
921 unset z
922 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
923 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
924 do z="${z}0";
925 done
926 PATCH_ORDER="${z}${STRICT_COUNT}"
927
928 mkdir -p "${KPATCH_DIR}/${PATCH_ORDER}"
929 pushd "${KPATCH_DIR}/${PATCH_ORDER}" >/dev/null
930 unpack ${i##*/}
931 popd >/dev/null
932 else
933 pushd "${KPATCH_DIR}" >/dev/null
934 unpack ${i##*/}
935 popd >/dev/null
936 fi
937
938 [[ ${i} == *:* ]] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
939 else
940 extention=${i/*./}
941 extention=${extention/:*/}
942 PIPE_CMD=""
943 case ${extention} in
944 xz) PIPE_CMD="xz -dc";;
945 lzma) PIPE_CMD="lzma -dc";;
946 bz2) PIPE_CMD="bzip2 -dc";;
947 patch*) PIPE_CMD="cat";;
948 diff) PIPE_CMD="cat";;
949 gz|Z|z) PIPE_CMD="gzip -dc";;
950 ZIP|zip) PIPE_CMD="unzip -p";;
951 *) UNIPATCH_DROP="${UNIPATCH_DROP} ${i/:*/}";;
952 esac
953
954 PATCH_LEVEL=${i/*([^:])?(:)}
955 i=${i/:*/}
956 x=${i/*\//}
957 x=${x/\.${extention}/}
958
959 if [ -n "${PIPE_CMD}" ]; then
960 if [ ! -r "${i}" ]; then
961 echo
962 eerror "FATAL: unable to locate:"
963 eerror "${i}"
964 eerror "for read-only. The file either has incorrect permissions"
965 eerror "or does not exist."
966 die Unable to locate ${i}
967 fi
968
969 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
970 unset z
971 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
972 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
973 do z="${z}0";
974 done
975 PATCH_ORDER="${z}${STRICT_COUNT}"
976
977 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/
978 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
979 else
980 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
981 fi
982 fi
983 fi
984
985 # If experimental was not chosen by the user, drop experimental patches not in K_EXP_GENPATCHES_LIST.
986 if [[ "${i}" == *"genpatches-"*".experimental."* && -n ${K_EXP_GENPATCHES_PULL} ]] ; then
987 if [[ -z ${K_EXP_GENPATCHES_NOUSE} ]] && use experimental; then
988 continue
989 fi
990
991 local j
992 for j in ${KPATCH_DIR}/*/50*_*.patch*; do
993 for k in ${K_EXP_GENPATCHES_LIST} ; do
994 [[ "$(basename ${j})" == ${k}* ]] && continue 2
995 done
996 UNIPATCH_DROP+=" $(basename ${j})"
997 done
998 fi
999 done
1000
1001 #populate KPATCH_DIRS so we know where to look to remove the excludes
1002 x=${KPATCH_DIR}
1003 KPATCH_DIR=""
1004 for i in $(find ${x} -type d | sort -n); do
1005 KPATCH_DIR="${KPATCH_DIR} ${i}"
1006 done
1007
1008 # do not apply fbcondecor patch to sparc/sparc64 as it breaks boot
1009 # bug #272676
1010 if [[ "$(tc-arch)" = "sparc" || "$(tc-arch)" = "sparc64" ]]; then
1011 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.28 ]]; then
1012 UNIPATCH_DROP="${UNIPATCH_DROP} *_fbcondecor-0.9.6.patch"
1013 echo
1014 ewarn "fbcondecor currently prevents sparc/sparc64 from booting"
1015 ewarn "for kernel versions >= 2.6.29. Removing fbcondecor patch."
1016 ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=272676 for details"
1017 echo
1018 fi
1019 fi
1020
1021 #so now lets get rid of the patchno's we want to exclude
1022 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}"
1023 for i in ${UNIPATCH_DROP}; do
1024 ebegin "Excluding Patch #${i}"
1025 for x in ${KPATCH_DIR}; do rm -f ${x}/${i}* 2>/dev/null; done
1026 eend $?
1027 done
1028
1029 # and now, finally, we patch it :)
1030 for x in ${KPATCH_DIR}; do
1031 for i in $(find ${x} -maxdepth 1 -iname "*.patch*" -or -iname "*.diff*" | sort -n); do
1032 STDERR_T="${T}/${i/*\//}"
1033 STDERR_T="${STDERR_T/.patch*/.err}"
1034
1035 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/}
1036 #[ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/}
1037
1038 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
1039
1040 while [ ${PATCH_DEPTH} -lt 5 ]; do
1041 echo "Attempting Dry-run:" >> ${STDERR_T}
1042 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
1043 echo "=======================================================" >> ${STDERR_T}
1044 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
1045 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH})"
1046 echo "Attempting patch:" > ${STDERR_T}
1047 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
1048 echo "=======================================================" >> ${STDERR_T}
1049 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
1050 eend 0
1051 rm ${STDERR_T}
1052 break
1053 else
1054 eend 1
1055 eerror "Failed to apply patch ${i/*\//}"
1056 eerror "Please attach ${STDERR_T} to any bug you may post."
1057 eshopts_pop
1058 die "Failed to apply ${i/*\//} on patch depth ${PATCH_DEPTH}."
1059 fi
1060 else
1061 PATCH_DEPTH=$((${PATCH_DEPTH} + 1))
1062 fi
1063 done
1064 if [ ${PATCH_DEPTH} -eq 5 ]; then
1065 eerror "Failed to dry-run patch ${i/*\//}"
1066 eerror "Please attach ${STDERR_T} to any bug you may post."
1067 eshopts_pop
1068 die "Unable to dry-run patch on any patch depth lower than 5."
1069 fi
1070 done
1071 done
1072
1073 # When genpatches is used, we want to install 0000_README which documents
1074 # the patches that were used; such that the user can see them, bug #301478.
1075 if [[ ! -z ${K_WANT_GENPATCHES} ]] ; then
1076 UNIPATCH_DOCS="${UNIPATCH_DOCS} 0000_README"
1077 fi
1078
1079 # When files listed in UNIPATCH_DOCS are found in KPATCH_DIR's, we copy it
1080 # to the temporary directory and remember them in UNIPATCH_DOCS to install
1081 # them during the install phase.
1082 local tmp
1083 for x in ${KPATCH_DIR}; do
1084 for i in ${UNIPATCH_DOCS}; do
1085 if [[ -f "${x}/${i}" ]] ; then
1086 tmp="${tmp} ${i}"
1087 cp -f "${x}/${i}" "${T}"/
1088 fi
1089 done
1090 done
1091 UNIPATCH_DOCS="${tmp}"
1092
1093 # clean up KPATCH_DIR's - fixes bug #53610
1094 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
1095
1096 LC_ALL="${myLC_ALL}"
1097 LANG="${myLANG}"
1098 eshopts_pop
1099 }
1100
1101 # getfilevar accepts 2 vars as follows:
1102 # getfilevar <VARIABLE> <CONFIGFILE>
1103 # pulled from linux-info
1104
1105 getfilevar() {
1106 local workingdir basefname basedname xarch=$(tc-arch-kernel)
1107
1108 if [[ -z ${1} ]] && [[ ! -f ${2} ]]; then
1109 echo -e "\n"
1110 eerror "getfilevar requires 2 variables, with the second a valid file."
1111 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
1112 else
1113 workingdir=${PWD}
1114 basefname=$(basename ${2})
1115 basedname=$(dirname ${2})
1116 unset ARCH
1117
1118 cd ${basedname}
1119 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
1120 make ${BUILD_FIXES} -s -f - e 2>/dev/null
1121 cd ${workingdir}
1122
1123 ARCH=${xarch}
1124 fi
1125 }
1126
1127 detect_arch() {
1128 # This function sets ARCH_URI and ARCH_PATCH
1129 # with the neccessary info for the arch sepecific compatibility
1130 # patchsets.
1131
1132 local ALL_ARCH LOOP_ARCH COMPAT_URI i
1133
1134 # COMPAT_URI is the contents of ${ARCH}_URI
1135 # ARCH_URI is the URI for all the ${ARCH}_URI patches
1136 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH
1137
1138 ARCH_URI=""
1139 ARCH_PATCH=""
1140 ALL_ARCH="ALPHA AMD64 ARM HPPA IA64 M68K MIPS PPC PPC64 S390 SH SPARC X86"
1141
1142 for LOOP_ARCH in ${ALL_ARCH}; do
1143 COMPAT_URI="${LOOP_ARCH}_URI"
1144 COMPAT_URI="${!COMPAT_URI}"
1145
1146 [[ -n ${COMPAT_URI} ]] && \
1147 ARCH_URI="${ARCH_URI} $(echo ${LOOP_ARCH} | tr '[:upper:]' '[:lower:]')? ( ${COMPAT_URI} )"
1148
1149 if [[ ${LOOP_ARCH} == "$(echo $(tc-arch-kernel) | tr '[:lower:]' '[:upper:]')" ]]; then
1150 for i in ${COMPAT_URI}; do
1151 ARCH_PATCH="${ARCH_PATCH} ${DISTDIR}/${i/*\//}"
1152 done
1153 fi
1154 done
1155 }
1156
1157 headers___fix() {
1158 # Voodoo to partially fix broken upstream headers.
1159 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
1160 sed -i \
1161 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
1162 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
1163 -e "s/\([[:space:]]\)inline\([[:space:](]\)/\1__inline__\2/g" \
1164 -e "s/\([[:space:]]\)asm\([[:space:](]\)/\1__asm__\2/g" \
1165 -e "s/\([[:space:]]\)volatile\([[:space:](]\)/\1__volatile__\2/g" \
1166 "$@"
1167 }
1168
1169 # common functions
1170 #==============================================================
1171 kernel-2_src_unpack() {
1172 universal_unpack
1173 debug-print "Doing unipatch"
1174
1175 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
1176 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
1177
1178 debug-print "Doing premake"
1179
1180 # allow ebuilds to massage the source tree after patching but before
1181 # we run misc `make` functions below
1182 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
1183
1184 debug-print "Doing epatch_user"
1185 epatch_user
1186
1187 debug-print "Doing unpack_set_extraversion"
1188
1189 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
1190 unpack_fix_install_path
1191
1192 # Setup xmakeopts and cd into sourcetree.
1193 env_setup_xmakeopts
1194 cd "${S}"
1195
1196 # We dont need a version.h for anything other than headers
1197 # at least, I should hope we dont. If this causes problems
1198 # take out the if/fi block and inform me please.
1199 # unpack_2_6 should now be 2.6.17 safe anyways
1200 if [[ ${ETYPE} == headers ]]; then
1201 kernel_is 2 4 && unpack_2_4
1202 kernel_is 2 6 && unpack_2_6
1203 fi
1204
1205 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1206 cp "${DISTDIR}/${DEBLOB_A}" "${T}" || die "cp ${DEBLOB_A} failed"
1207 cp "${DISTDIR}/${DEBLOB_CHECK_A}" "${T}/deblob-check" || die "cp ${DEBLOB_CHECK_A} failed"
1208 chmod +x "${T}/${DEBLOB_A}" "${T}/deblob-check" || die "chmod deblob scripts failed"
1209 fi
1210
1211 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
1212 # only do this for kernel < 2.6.27 since this file does not exist in later
1213 # kernels
1214 if [[ -n ${KV_MINOR} && ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]] ; then
1215 sed -i \
1216 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
1217 "${S}"/arch/ppc/Makefile
1218 else
1219 sed -i \
1220 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
1221 "${S}"/arch/powerpc/Makefile
1222 fi
1223 }
1224
1225 kernel-2_src_compile() {
1226 cd "${S}"
1227 [[ ${ETYPE} == headers ]] && compile_headers
1228
1229 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1230 echo ">>> Running deblob script ..."
1231 sh "${T}/${DEBLOB_A}" --force || die "Deblob script failed to run!!!"
1232 fi
1233 }
1234
1235 # if you leave it to the default src_test, it will run make to
1236 # find whether test/check targets are present; since "make test"
1237 # actually produces a few support files, they are installed even
1238 # though the package is binchecks-restricted.
1239 #
1240 # Avoid this altogether by making the function moot.
1241 kernel-2_src_test() { :; }
1242
1243 kernel-2_pkg_preinst() {
1244 [[ ${ETYPE} == headers ]] && preinst_headers
1245 }
1246
1247 kernel-2_src_install() {
1248 install_universal
1249 [[ ${ETYPE} == headers ]] && install_headers
1250 [[ ${ETYPE} == sources ]] && install_sources
1251 }
1252
1253 kernel-2_pkg_postinst() {
1254 [[ ${ETYPE} == sources ]] && postinst_sources
1255 }
1256
1257 kernel-2_pkg_setup() {
1258 if kernel_is 2 4; then
1259 if [[ $(gcc-major-version) -ge 4 ]] ; then
1260 echo
1261 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1262 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1263 ewarn "newer kernel that supports gcc-4."
1264 echo
1265 ewarn "Also be aware that bugreports about gcc-4 not working"
1266 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1267 echo
1268 epause 10
1269 fi
1270 fi
1271
1272 ABI="${KERNEL_ABI}"
1273 [[ ${ETYPE} == headers ]] && setup_headers
1274 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
1275 }
1276
1277 kernel-2_pkg_postrm() {
1278 # This warning only makes sense for kernel sources.
1279 [[ ${ETYPE} == headers ]] && return 0
1280
1281 # If there isn't anything left behind, then don't complain.
1282 [[ -e ${ROOT}usr/src/linux-${KV_FULL} ]] || return 0
1283 echo
1284 ewarn "Note: Even though you have successfully unmerged "
1285 ewarn "your kernel package, directories in kernel source location: "
1286 ewarn "${ROOT}usr/src/linux-${KV_FULL}"
1287 ewarn "with modified files will remain behind. By design, package managers"
1288 ewarn "will not remove these modified files and the directories they reside in."
1289 echo
1290 }

  ViewVC Help
Powered by ViewVC 1.1.20